/* ----------------------------------------------------------------------------
 * This file was automatically generated by SWIG (http://www.swig.org).
 * Version 4.0.2
 *
 * Do not make changes to this file unless you know what you are doing--modify
 * the SWIG interface file instead.
 * ----------------------------------------------------------------------------- */
package com.herumi.mcl

import kotlin.jvm.JvmOverloads
import com.herumi.mcl.MclJNI
import kotlin.jvm.Synchronized
import com.herumi.mcl.Fp
import com.herumi.mcl.Fr
import com.herumi.mcl.G1
import com.herumi.mcl.G2
import com.herumi.mcl.GT
import com.herumi.mcl.MclConstants
import com.herumi.mcl.SWIGTYPE_p_bool
import com.herumi.mcl.ElgamalJNI
import com.herumi.mcl.CipherText

class GT protected constructor(
    @field:Transient private var swigCPtr: Long,
    @field:Transient protected var swigCMemOwn: Boolean
) {
    protected fun finalize() {
        delete()
    }

    @Synchronized
    fun delete() {
        if (swigCPtr != 0L) {
            if (swigCMemOwn) {
                swigCMemOwn = false
                MclJNI.delete_GT(swigCPtr)
            }
            swigCPtr = 0
        }
    }

    constructor() : this(MclJNI.new_GT__SWIG_0(), true) {}
    constructor(rhs: GT?) : this(MclJNI.new_GT__SWIG_1(getCPtr(rhs), rhs), true) {}

    fun equals(rhs: GT?): Boolean {
        return MclJNI.GT_equals(swigCPtr, this, getCPtr(rhs), rhs)
    }

    val isOne: Boolean
        get() = MclJNI.GT_isOne(swigCPtr, this)

    fun clear() {
        MclJNI.GT_clear(swigCPtr, this)
    }

    fun setStr(str: String?, base: Int) {
        MclJNI.GT_setStr__SWIG_0(swigCPtr, this, str, base)
    }

    fun setStr(str: String?) {
        MclJNI.GT_setStr__SWIG_1(swigCPtr, this, str)
    }

    fun toString(base: Int): String? {
        return MclJNI.GT_toString__SWIG_0(swigCPtr, this, base)
    }

    override fun toString(): String {
        return MclJNI.GT_toString__SWIG_1(swigCPtr, this)!!
    }

    fun deserialize(cbuf: ByteArray?) {
        MclJNI.GT_deserialize(swigCPtr, this, cbuf)
    }

    fun serialize(): ByteArray? {
        return MclJNI.GT_serialize(swigCPtr, this)
    }

    companion object {
        fun getCPtr(obj: GT?): Long {
            return obj?.swigCPtr ?: 0
        }
    }
}